# -*- coding: utf-8 -*- 
# @Time    : 03/24/2024 
# @Author  : nzooherd 
# @File    : message.py 
# @Software: Visual Studio Code


import base64
import functools
from typing import Callable, Coroutine, Union

from telethon.events import NewMessage, ButtonCallback

from logging import getLogger

from service.message_service import MessageService

logger = getLogger()


class MessageAspect:
    """
    TODO()
    """

    def __init__(self, param1 = None, param2 = None) -> None:
        self.param1 = param1
        self.param2 = param2

        self.message_service = MessageService()

    def __call__(self, handler: Callable[[object, NewMessage], Coroutine]):
        @functools.wraps(handler)
        async def wrapper(controller: object, update: Union[NewMessage, ButtonCallback]):
            if isinstance(update, NewMessage):
                #TODO()
                logger.info(f"Receving message: {update.text}")
            if isinstance(update, ButtonCallback):
                #TODO()
                logger.info(f"Receving callback: {base64.b64encode(update.data).decode('utf-8')}")

            await self.message_service.receive_message(update)
            await handler(controller, update)
        return wrapper